#!/bin/sh


. ./config.dat

#Ҫָ
PATH="${PREFIX}/bin:${PATH}"


tar -xvjf cygwin-1.5.25-15-src.tar.bz2
SRC_DIR_ORIGINAL=cygwin-1.5.25-15
SRC_DIR="${SRC_DIR_ORIGINAL}-src"
BUILD_DIR="${SRC_DIR_ORIGINAL}-build"

mv ${SRC_DIR_ORIGINAL} ${SRC_DIR}

SRC_DIR_ABSOLUTE_PATH=`cd ${SRC_DIR}; pwd`


(
	cd ${SRC_DIR}
	patch -Np1  <../cygwin-1.5.25-15_1.patch
	patch -Np1  <../newlib-no-doc1.patch
	patch -Np1  <../libiberty-configure.ac.patch
	patch -Np1  <../cygwin_configure.in.patch
	patch -Np1  <../mingw_1.patch
	cd ..
	
	
	rm -rf $BUILD_DIR
	
	mkdir  $BUILD_DIR

	SRC_DIR_ABSOLUTE_PATH=`cd ${SRC_DIR}; pwd`
	BUILD_DIR_ABSOLUTE_PATH=`cd ${BUILD_DIR}; pwd`


	cd  $BUILD_DIR
	
	mkdir -p newlib libiberty winsup


	(

		cd newlib;
		CC="i686-pc-cygwin-gcc -L${BUILD_DIR_ABSOLUTE_PATH}/winsup -L${BUILD_DIR_ABSOLUTE_PATH}/winsup/cygwin -L${BUILD_DIR_ABSOLUTE_PATH}/winsup/w32api/lib -isystem ${SRC_DIR_ABSOLUTE_PATH}/winsup/include -isystem ${SRC_DIR_ABSOLUTE_PATH}/winsup/cygwin/include -isystem ${SRC_DIR_ABSOLUTE_PATH}/winsup/w32api/include -B${BUILD_DIR_ABSOLUTE_PATH}/newlib/ -isystem ${BUILD_DIR_ABSOLUTE_PATH}/newlib/targ-include -isystem ${SRC_DIR_ABSOLUTE_PATH}/newlib/libc/include"  \
		CFLAGS="-O2 -g" \
		../../${SRC_DIR}/newlib/configure --prefix=${PREFIX} --host="$TARGET" --build=`../../config.guess` \
		 --with-newlib --enable-multilib \
		&& make \
		&& make install

	) \
	&& (

		pushd ../${SRC_DIR}/libiberty
		autoconf
		popd
	
		cd libiberty;
		CC="i686-pc-cygwin-gcc -L${BUILD_DIR_ABSOLUTE_PATH}/winsup -L${BUILD_DIR_ABSOLUTE_PATH}/winsup/cygwin -L${BUILD_DIR_ABSOLUTE_PATH}/winsup/w32api/lib -isystem ${SRC_DIR_ABSOLUTE_PATH}/winsup/include -isystem ${SRC_DIR_ABSOLUTE_PATH}/winsup/cygwin/include -isystem ${SRC_DIR_ABSOLUTE_PATH}/winsup/w32api/include -B${BUILD_DIR_ABSOLUTE_PATH}/newlib/ -isystem ${BUILD_DIR_ABSOLUTE_PATH}/newlib/targ-include -isystem ${SRC_DIR_ABSOLUTE_PATH}/newlib/libc/include"  \
		CFLAGS="-O2 -g" \
		../../${SRC_DIR}/libiberty/configure --prefix=${PREFIX}/"$TARGET" --host="$TARGET" --build=`../../config.guess` \
		 --with-newlib --enable-multilib \
		&& make \
		&& make install

	) \
	&& (
	
		cd winsup;
		mkdir -p  w32api mingw 

		cd w32api

		CC="i686-pc-cygwin-gcc -L${BUILD_DIR_ABSOLUTE_PATH}/winsup -L${BUILD_DIR_ABSOLUTE_PATH}/winsup/cygwin -L${BUILD_DIR_ABSOLUTE_PATH}/winsup/w32api/lib -isystem ${SRC_DIR_ABSOLUTE_PATH}/winsup/include -isystem ${SRC_DIR_ABSOLUTE_PATH}/winsup/cygwin/include -isystem ${SRC_DIR_ABSOLUTE_PATH}/winsup/w32api/include -B${BUILD_DIR_ABSOLUTE_PATH}/newlib/ -isystem ${BUILD_DIR_ABSOLUTE_PATH}/newlib/targ-include -isystem ${SRC_DIR_ABSOLUTE_PATH}/newlib/libc/include"  \
		CFLAGS="-O2 -g" \
		CXX="i686-pc-cygwin-g++ -L${BUILD_DIR_ABSOLUTE_PATH}/winsup -L${BUILD_DIR_ABSOLUTE_PATH}/winsup/cygwin -L${BUILD_DIR_ABSOLUTE_PATH}/winsup/w32api/lib -isystem ${SRC_DIR_ABSOLUTE_PATH}/winsup/include -isystem ${SRC_DIR_ABSOLUTE_PATH}/winsup/cygwin/include -isystem ${SRC_DIR_ABSOLUTE_PATH}/winsup/w32api/include -B${BUILD_DIR_ABSOLUTE_PATH}/newlib/ -isystem ${BUILD_DIR_ABSOLUTE_PATH}/newlib/targ-include -isystem ${SRC_DIR_ABSOLUTE_PATH}/newlib/libc/include"  \
		CXXFLAGS="-O2 -g" \
		../../../${SRC_DIR}/winsup/w32api/configure --prefix=${PREFIX}/"$TARGET" --host="$TARGET" --build=`../../../config.guess` \
		 --with-newlib --enable-multilib \
		&& make \
		&& make install

		cd ..





		pushd ../../${SRC_DIR}/winsup/mingw

		autoconf
		cd profile; autoconf; cd ..;
		cd mingwex; autoconf; cd ..;
		
		popd

		cd mingw
		
		CC="i686-pc-cygwin-gcc -L${BUILD_DIR_ABSOLUTE_PATH}/winsup -L${BUILD_DIR_ABSOLUTE_PATH}/winsup/cygwin -L${BUILD_DIR_ABSOLUTE_PATH}/winsup/w32api/lib -isystem ${SRC_DIR_ABSOLUTE_PATH}/winsup/include -isystem ${SRC_DIR_ABSOLUTE_PATH}/winsup/cygwin/include -isystem ${SRC_DIR_ABSOLUTE_PATH}/winsup/w32api/include -B${BUILD_DIR_ABSOLUTE_PATH}/newlib/ -isystem ${BUILD_DIR_ABSOLUTE_PATH}/newlib/targ-include -isystem ${SRC_DIR_ABSOLUTE_PATH}/newlib/libc/include -D__MINGW32__ -U__CYGWIN__"  \
		CFLAGS="-O2 -g" \
		CXX="i686-pc-cygwin-g++ -L${BUILD_DIR_ABSOLUTE_PATH}/winsup -L${BUILD_DIR_ABSOLUTE_PATH}/winsup/cygwin -L${BUILD_DIR_ABSOLUTE_PATH}/winsup/w32api/lib -isystem ${SRC_DIR_ABSOLUTE_PATH}/winsup/include -isystem ${SRC_DIR_ABSOLUTE_PATH}/winsup/cygwin/include -isystem ${SRC_DIR_ABSOLUTE_PATH}/winsup/w32api/include -B${BUILD_DIR_ABSOLUTE_PATH}/newlib/ -isystem ${BUILD_DIR_ABSOLUTE_PATH}/newlib/targ-include -isystem ${SRC_DIR_ABSOLUTE_PATH}/newlib/libc/include -D__MINGW32__ -U__CYGWIN__"  \
		CXXFLAGS="-O2 -g" \
		../../../${SRC_DIR}/winsup/mingw/configure --prefix=${PREFIX}/"$TARGET"/mingw --host="$TARGET" --build=`../../../config.guess` \
		 --with-newlib --enable-multilib \
		&& make \
		&& make install \
		&& ( rm -rf ${PREFIX}/"$TARGET"/include/mingw ) \
		&& ( rm -rf ${PREFIX}/"$TARGET"/lib/mingw ) \
		&& ( mv ${PREFIX}/"$TARGET"/mingw/include ${PREFIX}/"$TARGET"/include/mingw ) \
		&& ( mv ${PREFIX}/"$TARGET"/mingw/lib ${PREFIX}/"$TARGET"/lib/mingw ) \
		&& ( rm -rf ${PREFIX}/"$TARGET"/mingw )

		cd ..





	) \
	&& (

		cd winsup;
		mkdir -p  cygwin

		pushd ../../${SRC_DIR}/winsup/cygwin
		autoconf
		popd

		cd cygwin

		CC="i686-pc-cygwin-gcc -L${BUILD_DIR_ABSOLUTE_PATH}/winsup -L${BUILD_DIR_ABSOLUTE_PATH}/winsup/cygwin -L${BUILD_DIR_ABSOLUTE_PATH}/winsup/w32api/lib -isystem ${SRC_DIR_ABSOLUTE_PATH}/winsup/include -isystem ${SRC_DIR_ABSOLUTE_PATH}/winsup/cygwin/include -isystem ${SRC_DIR_ABSOLUTE_PATH}/winsup/w32api/include -B${BUILD_DIR_ABSOLUTE_PATH}/newlib/ -isystem ${BUILD_DIR_ABSOLUTE_PATH}/newlib/targ-include -isystem ${SRC_DIR_ABSOLUTE_PATH}/newlib/libc/include"  \
		CFLAGS="-O2 -g" \
		CXX="i686-pc-cygwin-g++ -L${BUILD_DIR_ABSOLUTE_PATH}/winsup -L${BUILD_DIR_ABSOLUTE_PATH}/winsup/cygwin -L${BUILD_DIR_ABSOLUTE_PATH}/winsup/w32api/lib -isystem ${SRC_DIR_ABSOLUTE_PATH}/winsup/include -isystem ${SRC_DIR_ABSOLUTE_PATH}/winsup/cygwin/include -isystem ${SRC_DIR_ABSOLUTE_PATH}/winsup/w32api/include -B${BUILD_DIR_ABSOLUTE_PATH}/newlib/ -isystem ${BUILD_DIR_ABSOLUTE_PATH}/newlib/targ-include -isystem ${SRC_DIR_ABSOLUTE_PATH}/newlib/libc/include"  \
		CXXFLAGS="-O2 -g" \
		../../../${SRC_DIR}/winsup/cygwin/configure --prefix=${PREFIX}/"$TARGET" --host="$TARGET" --build=`../../../config.guess` \
		 --with-newlib --enable-multilib \
		 --disable-server \
		&& make \
		&& make install

		cd ..

	)

) 2>&1 | tee  output.txt

unix2dos output.txt

