#!/bin/sh

. ./config.dat

PATH="${PREFIX}/bin:${PATH}"


tar -xvzf w32api-3.13-mingw32-src.tar.gz
mv w32api-3.13-mingw32 w32api
tar -xvzf mingwrt-3.15.2-mingw32-src.tar.gz
mv mingwrt-3.15.2-mingw32 mingwrt






rm -rf w32api-build
mkdir w32api-build

cd w32api-build

CFLAGS="-I`pwd`/../w32api/include -I`pwd`/../mingwrt/include"  \
CPPFLAGS="-I`pwd`/../w32api/include -I`pwd`/../mingwrt/include"  \
../w32api/configure --prefix=${PREFIX}/"$TARGET" --host="$TARGET" --build=`../config.guess` && make && make install

cd ..







cd mingwrt
patch -Np1 <../mingwrt_without_mingwm10.dll.patch
patch -Np1 <../mingwrt_remove_NO_CYGWIN.patch
patch -Np1 <../mingwrt_types.patch

autoconf
cd profile; autoconf;  cd ..
cd mingwex; autoconf;  cd ..

cd ..


rm -rf mingwrt-build
mkdir mingwrt-build

cd mingwrt-build

CFLAGS="-I`pwd`/../w32api/include -I`pwd`/../mingwrt/include -D__MINGW32__ -U__CYGWIN__"  \
CPPFLAGS="-I`pwd`/../w32api/include -I`pwd`/../mingwrt/include -D__MINGW32__ -U__CYGWIN__"  \
../mingwrt/configure --prefix=${PREFIX}/"$TARGET"/mingw --host="$TARGET" --build=`../config.guess`   && make && make install \
&& ( rm -rf ${PREFIX}/"$TARGET"/include/mingw ) \
&& ( rm -rf ${PREFIX}/"$TARGET"/lib/mingw ) \
&& ( mv ${PREFIX}/"$TARGET"/mingw/include ${PREFIX}/"$TARGET"/include/mingw ) \
&& ( mv ${PREFIX}/"$TARGET"/mingw/lib ${PREFIX}/"$TARGET"/lib/mingw ) \
&& ( rm -rf ${PREFIX}/"$TARGET"/mingw )

cd ..
