#!/bin/sh

cp -f ../../packages/binutils/binutils-2.20.tar.bz2     ./
cp -f ../../packages/gmp/gmp-4.2.2.tar.bz2     ./
cp -f ../../packages/mpfr/mpfr-2.3.1.tar.bz2     ./
cp -f ../../packages/gcc/gcc-4.4.2.tar.bz2     ./
cp -f ../../packages/cygwin/cygwin-1.5.25-15-src.tar.bz2     ./
cp -f ../../packages/w32api/w32api-3.13-mingw32-src.tar.gz     ./
cp -f ../../packages/mingwrt/mingwrt-3.15.2-mingw32-src.tar.gz     ./


./build_binutils.sh  \
&& ./build_gmp.sh   \
&& ./build_mpfr.sh  \
&& ./build_gcc_0.sh  \
&& ./build_cygwin.sh  \
&& ./build_gcc_1.sh
